using PkmnLib.Dynamic.Models;

namespace PkmnLib.Dynamic.Events;

/// <summary>
/// Event triggered when a Pokemon faints.
/// </summary>
public class FaintEvent : IEventData
{
    /// <inheritdoc cref="FaintEvent"/>
    public FaintEvent(IPokemon pokemon)
    {
        Pokemon = pokemon;
    }

    /// <summary>
    /// The Pokemon that fainted.
    /// </summary>
    public IPokemon Pokemon { get; init; }
    
    /// <inheritdoc />
    public EventBatchId BatchId { get; init; } = new();
}